function SceneError(options)
{
	this.options = options;
}

SceneError.prototype.initialize = function ()
{
	alert("SceneError.initialize()");
}

SceneError.prototype.popupCallback = function(data)
{
    alert("SceneError.popupCallback(), data=" + data);
    
    $.sfScene.hide("Error");
    
    var caller = $.sfScene.get("Error").options.caller;
    
	switch (caller)
    {
        case "NavigationMenuCategories":
            $.sfScene.focus("NavigationMenuCategories");
            $("#menuCategoriesListbox").empty();
            break;
            
        case "NavigationMenuMovies":
            $.sfScene.focus("NavigationMenuMovies");
            $("#menuMoviesListbox").empty();
            $("#movieLoading").hide();
            break;
            
        case "Player":
            $.sfScene.focus("Player");
            $.sfScene.get("Main").goBack();
            break;
            
        case "Movie":
            $.sfScene.focus("NavigationMenuMovies");
            $("#movieLoading").hide();
            break;
            
        case "MoviesPanel":
            $.sfScene.focus("NavigationMenuCategories");
            $("#moviesPanel").empty();
            break;
            
        default:
            $.sfScene.focus("Main");
            $("#mainLoading").empty();
            break;
	}
}

SceneError.prototype.handleShow = function ()
{
	alert("SceneError.handleShow()");
}

SceneError.prototype.handleHide = function ()
{
	alert("SceneError.handleHide()");
}

SceneError.prototype.handleFocus = function ()
{
	alert("SceneError.handleFocus()");
    
    if (typeof this.options.popupMsg == "undefined" || this.options.popupMsg == "")
    {
        $("#popup").sfPopup( {text: "Wystąpił nieznany błąd.", num:"1", callback: this.popupCallback} );
    }
    else
    {
        $("#popup").sfPopup( {text: this.options.popupMsg, num:"1", callback: this.popupCallback} );
    }
    
    $("#popup").sfPopup("show");
}

SceneError.prototype.handleBlur = function ()
{
	alert("SceneError.handleBlur()");
}

SceneError.prototype.handleKeyDown = function (keyCode)
{
	alert("SceneError.handleKeyDown(" + keyCode + ")");
    
	switch (keyCode)
    {
        case $.sfKey.RETURN:
            $.sfKey.block();
            $.sfScene.get("Main").goBack();
            break;
	}
}
