function SceneMain(options)
{
	this.options = options;
    this.prevScene = [];
    this.selfState = {};
}

SceneMain.prototype.initialize = function ()
{
	alert("SceneMain.initialize()");
    
    this.selfState.url = conf.mainFeed;
    this.selfState.caption = "";
    this.selfState.type = "category";
    this.selfState.cursor = 0;
    
    this.helpBar({"return": "Wyjdź"});
    
    var caller = this;
    
    geoXHR =  this.getXHRObj("Geoblock");
    geoXHR.sendXHRRequest(conf.geoblockUrl, function (result, respObj)
    {
        if (result)
        {
            var resp = $.parseJSON(respObj.responseText);
            
            if (resp.valid)
            {
                caller.sendRequestForData(caller.selfState);
            }
            else
            {
                caller.showError("Main", "Przepraszamy, nasza biblioteka filmów dostępna jest jedynie dla użytkowników znajdujących się na terenie Polski.<br /><br />Sorry, currently our video library can only be streamed from within Poland.");
            }
        }
        else
        {
            caller.showError("Main", "Przepraszamy, wystąpił błąd z połączeniem [0x0].<br />Prosimy spróbować ponownie za chwilę.");
        }
    });
}

SceneMain.prototype.sendRequestForData = function(newScene, oldScene)
{
    if (typeof newScene != "object")
    {
        alert("sendRequestForData: Object expected");
        return false;
    }
    
    //alert("[URL] " + newScene.url);
    
    /*
    $.each(newScene, function(index, value)
    {
        alert("newScene "+index+": "+value);
    });
    
    if (typeof oldScene == "object")
    {
        $.each(oldScene, function(index, value)
        {
            alert("oldScene "+index+": "+value);
        });
    }
    */
    
    if (typeof oldScene == "object")
    {
        this.prevScene.push(oldScene);
    }
    
    if (newScene.type == "category")
    {
        $.sfScene.hide("NavigationMenuMovies");
        $.sfScene.hide("Movie");
        $.sfScene.hide("Player");
        $.sfScene.show("NavigationMenuCategories");
        $.sfScene.show("MoviesPanel");
        $.sfScene.focus("NavigationMenuCategories");
        $.sfScene.get("NavigationMenuCategories").sendRequestForData(newScene);
    }
    else if (newScene.type == "playlist")
    {
        $.sfScene.hide("NavigationMenuCategories");
        $.sfScene.hide("MoviesPanel");
        $.sfScene.hide("Player");
        $.sfScene.show("NavigationMenuMovies");
        $.sfScene.show("Movie");
        $.sfScene.focus("NavigationMenuMovies");
        $.sfScene.get("NavigationMenuMovies").sendRequestForData(newScene);
    }
    else if (newScene.type == "video")
    {
        $.sfScene.hide("NavigationMenuMovies");
        $.sfScene.hide("Movie");
        $.sfScene.hide("NavigationMenuCategories");
        $.sfScene.hide("MoviesPanel");
        $.sfScene.show("Player");
        $.sfScene.focus("Player");
        $.sfScene.get("Player").sendRequestForData(newScene);
    }
    else if (newScene.type == "movie_card")
    {
        $.sfScene.get("Movie").sendRequestForData(newScene);
    }
    else if (newScene.type == "series_card")
    {
        $.sfScene.get("Movie").sendRequestForData(newScene);
    }
    else
    {
        alert("sendRequestForData: Unsuported object type="+newScene.type);
        return false;
    }
    
    return true;
}

SceneMain.prototype.showError = function(caller, msg)
{
    if (typeof $.sfScene.get("Error").options == "undefined")
    {
        $.sfScene.get("Error").options = new Object();
    }
    
    $.sfScene.get("Error").options.caller = caller;
    $.sfScene.get("Error").options.popupMsg = msg;
    
    $.sfScene.show("Error");
    $.sfScene.focus("Error");
}

SceneMain.prototype.goBack = function()
{
    if (this.prevScene.length > 0)
    {
        this.sendRequestForData(this.prevScene.pop());
    }
    else
    {
        $.sf.exit (false);
    }
}

SceneMain.prototype.helpBar = function(params)
{
    $("#helpBar").sfKeyHelp(params);
}

SceneMain.prototype.getXHRObj = function(name)
{
    if (typeof name == "undefined")
    {
        return false;
    }
    
    if (typeof xhr[name] == "undefined")
    {
        xhr[name] = new XHRToolKit();
    }
    
    return xhr[name];
}

SceneMain.prototype.handleShow = function ()
{
	alert("SceneMain.handleShow()");
}

SceneMain.prototype.handleHide = function ()
{
	alert("SceneMain.handleHide()");
}

SceneMain.prototype.handleFocus = function ()
{
	alert("SceneMain.handleFocus()");
}

SceneMain.prototype.handleBlur = function ()
{
	alert("SceneMain.handleBlur()");
    
    $("#mainLoading").empty();
}

SceneMain.prototype.handleKeyDown = function (keyCode)
{
	alert("SceneMain.handleKeyDown(" + keyCode + ")");
    
	switch (keyCode)
    {
        case $.sfKey.RETURN:
            $.sfKey.block();
            this.goBack();
            break;
	}
}
