function SceneNavigationMenuCategories(options)
{
	this.options = options;
    this.selfState = new Object();
}

SceneNavigationMenuCategories.prototype.initialize = function ()
{
	alert("SceneNavigationMenuCategories.initialize()");
}

SceneNavigationMenuCategories.prototype.buildList = function (obj)
{
    var caller = this;
    
    if (obj.type != "category")
    {
        $.sfScene.get("Main").showError("NavigationMenuCategories", "Przepraszamy, wystąpił błąd serwera [1x1].");
        return false;
    }
    
    this.selfState.caption = obj.caption;
    
    $("#menuCategoriesLabel").html(obj.caption);
    
    if (obj.feeds.length == 0)
    {
        $.sfScene.get("Main").showError("NavigationMenuCategories", "Lista kategorii jest pusta [1x2].");
    }
    
    $("#menuCategoriesListbox").sfListbox2(
    {
        data: obj.feeds,
        itemsPerPage: 9,
        index: this.selfState.cursor,
        getElementContentCallback: function(obj)
        {
            if (typeof obj != "object")
            {
                alert("getElementContentCallback: Object expected");
                return "";
            }
            
            return obj.caption;
        },
        clickElementCallback: function(obj)
        {
            if (typeof obj != "object")
            {
                alert("clickElementCallback: Object expected");
                return false;
            }
            
            var newScene = new Object();
            newScene.url = obj.url;
            newScene.caption = obj.caption;
            newScene.type = obj.type;
            newScene.cursor = 0;
            
            return $.sfScene.get("Main").sendRequestForData(newScene, caller.selfState);
        }
    });
    
    this.helpBar();
    
    return true;
}

SceneNavigationMenuCategories.prototype.sendRequestForData = function (obj)
{
    $("#menuCategoriesListbox").html('<img src="images/loading.gif" class="loadingImage" />');
    
    this.selfState = obj;
    var caller = this;

    menuXHR =  $.sfScene.get("Main").getXHRObj("NavigationMenuCategories");
    menuXHR.sendXHRRequest(this.selfState.url, function (result, respObj)
    {
        if (result)
        {
            caller.buildList($.parseJSON(respObj.responseText));
            return true;
        }
        else
        {
            $.sfScene.get("Main").showError("NavigationMenuCategories", "Przepraszamy, wystąpił błąd z połączeniem [1x0].<br />Prosimy spróbować ponownie za chwilę.");
            return false;
        }
    });
}

SceneNavigationMenuCategories.prototype.helpBar = function ()
{
    var helpbar = new Object();
    
    if ($("#menuCategoriesListbox").getLengthData() != 0)
    {
        helpbar["updown"] = "Wybierz kategorię";
        helpbar["enter"] = "Zatwierdź wybór";
    }
    
    helpbar["leftright"] = "Przejdź do premier";
    
    var prevScene = $.sfScene.get("Main").prevScene;
    
    if (prevScene.length == 0)
    {
        helpbar["return"] = "Wyjdź";
    }
    else
    {
        if (typeof prevScene[prevScene.length - 1].caption == "")
        {
            helpbar["return"] = "Wróć";
        }
        else
        {
            helpbar["return"] = "Wróć do " + prevScene[prevScene.length - 1].caption;
        }
    }
    
    $.sfScene.get("Main").helpBar(helpbar);
}

SceneNavigationMenuCategories.prototype.focusListElement = function (position)
{
    $("#menuCategoriesListbox").sfListbox2("setPosition", position);
    this.selfState.cursor = $("#menuCategoriesListbox").sfListbox2("getIndex");
    $("#menuCategoriesListbox").sfListbox2("focus");
}

SceneNavigationMenuCategories.prototype.handleShow = function ()
{
	alert("SceneNavigationMenuCategories.handleShow()");
}

SceneNavigationMenuCategories.prototype.handleHide = function ()
{
	alert("SceneNavigationMenuCategories.handleHide()");
    
    $("#menuCategoriesListbox").sfListbox2("clear");
    $.sfScene.get("Main").getXHRObj("NavigationMenuCategories").abortXHRObj();
}

SceneNavigationMenuCategories.prototype.handleFocus = function ()
{
	alert("SceneNavigationMenuCategories.handleFocus()");
	
    $("#menuCategoriesListbox").sfListbox2("focus");
    this.helpBar();
}

SceneNavigationMenuCategories.prototype.handleBlur = function ()
{
	alert("SceneNavigationMenuCategories.handleBlur()");
	$("#menuCategoriesListbox").sfListbox2("blur");
}

SceneNavigationMenuCategories.prototype.handleKeyDown = function (keyCode)
{
	alert("SceneNavigationMenuCategories.handleKeyDown(" + keyCode + ")");
    
	switch (keyCode)
    {
		case $.sfKey.RIGHT:
            $.sfScene.focus("MoviesPanel");
			break;
            
            
		case $.sfKey.UP:
            $("#menuCategoriesListbox").sfListbox2("prev");
            this.selfState.cursor = $("#menuCategoriesListbox").sfListbox2("getIndex");
			break;
            
		case $.sfKey.DOWN:
            $("#menuCategoriesListbox").sfListbox2("next");
            this.selfState.cursor = $("#menuCategoriesListbox").sfListbox2("getIndex");
            break;
            
        
		case $.sfKey.ENTER:
            $("#menuCategoriesListbox").sfListbox2("click");
			break;
            
            
        case $.sfKey.RETURN:
            $.sfKey.block();
            $.sfScene.get("Main").goBack();
            break;
	}
}
