var XHRToolKit = function () 
{
    var URL = "";
    var sendResultFunc = function(){return true;};
    var XHRObj = null;
    
    this.sendXHRRequest = function(pURL, pSendResultFunc)
    {
        if (typeof pURL != "undefined")
        {
            URL = pURL;
        }
        
        //alert("sendXHRRequest(): " + URL);

        if (typeof pSendResultFunc != "undefined")
        {
            sendResultFunc = pSendResultFunc;
        }
        
        if (XHRObj)
        {
            XHRObj.destroy();
        }
            
        XHRObj = new XMLHttpRequest();
        
        if (XHRObj)
        {
            XHRObj.onreadystatechange = function ()
            {
                if (XHRObj.readyState == 4)
                {
                    receiveXHRResponse();
                }
            };
                        
            XHRObj.open("GET", URL, true);
            XHRObj.send(null);
        } 
        else
        {
            alert("XHR Object is NULL");
        }
    }

    var receiveXHRResponse = function ()
    {
        if (XHRObj.status == 200)
        {
            sendResultFunc(true, XHRObj);
        }
        else
        {
            sendResultFunc(false, XHRObj);
        }
    }

    this.getResponse = function ()
    {
        return XHRObj.responseText;
    }

    this.getXHRObj = function ()
    {
        return XHRObj;
    }

    this.abortXHRObj = function ()
    {
        if (XHRObj)
        {
            XHRObj.abort();
        }
    }
    
    this.destroyXHRObj = function()
    {
        if (XHRObj)
        {
            XHRObj.destroy();
        }
    }
}
