(function ($)
{
    var guard = false;
    
	$.fn.getNumberRows = function()
    {
		return $(this).data("itemsPerPage");
	}
    
	$.fn.getLengthData = function()
    {
		return $(this).data("data").length;
	}
    
	$.fn.isFocus = function()
    {
		return $(this).data("focus");
	}
    
	$.fn.isHorizontal = function()
    {
		return $(this).data("horizontal");
	}
    
	$.fn.sfListbox2 = function(options, value)
    {
		//alert("sfListbox2(" + $(this).attr("id") + ", " + options + ")");
        
		if (!($(this).data("sfui") == "sfListbox2"))
        {
			$(this)
				.data("data", [])
				.data("index", 0)
				.data("itemsPerPage", 5)
				.data("focus", false)
                .data("horizontal", false)
				.data("sfui", "sfListbox2")
                .data("getElementContentCallback", null)
                .data("clickElementCallback", null)
                .addClass("sf-ui-list");
		}
        
		if (typeof options == "object")
        {
			var defaults =
            {
				data: $(this).data("data"),
				index: $(this).data("index"), 
				itemsPerPage: $(this).data("itemsPerPage"),
                getElementContentCallback: $(this).data("getElementContentCallback"),
                clickElementCallback: $(this).data("clickElementCallback")
			}
            
			var opts = $.extend(defaults, options);
            
			$(this)
				.html(getDiv(opts.itemsPerPage))
				.data("data", opts.data)
				.data("index", opts.index)
				.data("itemsPerPage", opts.itemsPerPage)
                .data("getElementContentCallback", opts.getElementContentCallback)
                .data("clickElementCallback", opts.clickElementCallback);
                
			blur(this);
			
			if (options.index != undefined)
            {		
				$(this).data("focus", true);
				focus(this, opts.index);
			}
            
			insert(this, opts.index);
		}
        
        if (typeof options == "string")
        {
			switch (options)
            {
				case "prev":
				case "next":
					if (!$(this).data("focus"))
                    {
						$(this).sfListbox2("focus");
						$(this).data("focus", true);
						break;
					}
                    
                    if (guard)
                    {
                        break;
                    }
                    guard = true;
					
					var old = $(this).data("index");
					var itemsPerPage = $(this).data("itemsPerPage");
					var data = $(this).data("data");
					var next;
					
					if (options == "next")
                    {
						next = (Number(old) + 1 > data.length - 1) ? 0 : (Number(old) + 1);
                    }
					else 
                    {
						next = (Number(old) - 1 < 0) ? data.length - 1 : (Number(old) - 1);
                    }
                    
					if (getPage(old, itemsPerPage) != getPage(next, itemsPerPage))
                    {	
						insert(this, next);
					}
					
					blur (this, old);
					focus (this, next);
                    
					$(this).data("index", next);
                    
                    guard = false;
                    
					break;
                    
				case "getIndex":
					return $(this).data("index");
                    
				case "setIndex":
					if (isNaN(value))
                    {
						alert("Cannot set the index. Second parameter must be a number.");
                        break;
					}
                    
                    if ($(this).data("data").length -1 < value )
                    {
						alert("Cannot set the index. Index out of bounds.");
                        break;
                    }
                    
                    $(this).data("index", value);
                    blur(this);
					break;
                    
                case "setPosition":
					if (isNaN(value))
                    {
						alert("Cannot set the index. Second parameter must be a number.");
                        break;
					}
                    
                    var itemsPerPage = $(this).data("itemsPerPage");
                    var new_index = getPage($(this).data("index"), itemsPerPage) * itemsPerPage + value;
                    
                    if ($(this).data("data").length - 1 < new_index )
                    {
						alert("Cannot set the index. Index out of bounds.");
                        break;
                    }
                    
                    $(this).data("index", new_index);
                    
                    blur(this);
                    
                    break;
                    
                case "getCurrentElement":
                    return $(this).data("data")[$(this).data("index")];
                    break;
                    
				case "focus":
					focus(this, $(this).data("index"));
					$(this).data("focus", true);
					break;
                    
				case "blur":
					select(this, $(this).data("index"));
					$(this).data("focus", false);
					break;
                    
				case "clear":
                    $(this)
                        .html("")
                        .data("data", [])
                        .data("index", 0)
                        .data("itemsPerPage", 0)
                        .data("focus", false)
                        .data("getElementContentCallback", null)
                        .data("clickElementCallback", null);
					break;
                    
				case "show":
					$(this).show();
					break;
                    
				case "hide":
					$(this).hide();
					break;
                    
                 case "click":
                    clickElement(this, $(this).data("index"));
                    break;
                    
				default:
					break;
			}
		}
		return this;
	}
	
	function focus (self, index)
    {
		//alert("focus("+self+","+(index?index:"all")+")");
        
		var itemsPerPage = $(self).data("itemsPerPage");
		var selecter = (index === undefined) ? "" : ":nth-child("+(index%itemsPerPage+1)+")";
        
		$(self).children("div.content"+selecter)
			.removeClass(stateClasses)
			.addClass("sf-ui-list-focused_lst");
	}
	
	function blur (self, index)
    {
		//alert("blur("+self+","+(index?index:"all")+")");
        
		var itemsPerPage = $(self).data("itemsPerPage");
		var selecter = (index === undefined) ? "" : ":nth-child("+(index%itemsPerPage+1)+")";
		
		$(self).children("div.content"+selecter)
			.removeClass(stateClasses)
			.addClass("sf-ui-list-blured_lst");
	}
	
	function select (self, index)
    {
		//alert("select("+self+","+(index?index:"all")+")");
        
		var itemsPerPage = $(self).data("itemsPerPage");
		var selecter = (index === undefined) ? "" : ":nth-child("+(index%itemsPerPage+1)+")";
        
		$(self).children("div.content"+selecter)
			.removeClass(stateClasses)
			.addClass("sf-ui-list-selected_lst");
	}
	
	function insert (self, index)
    {
		//alert("insert("+self+","+index+")");
        
		var itemsPerPage = $(self).data("itemsPerPage");
		var data = $(self).data("data");
		var firstIndex = getPage(index, itemsPerPage) * itemsPerPage;
        var elementId;
        
        $(self).children("div.content").each(function(index, element)
        {
            elementId = Number(element.id);          
            
            $(element).removeClass("sf-ui-list-first_lst sf-ui-list-last_lst");
            
            if (index == 0)
            {
                $(element).addClass("sf-ui-list-first_lst");
            }
            else if (firstIndex + index + 1 == data.length)
            {
                $(element).addClass("sf-ui-list-last_lst");
            }
            
            if (firstIndex + index < data.length)
            {
                if (elementId == index)
                {
                    $(element).html(getElementContent(self, firstIndex + index)).removeClass("sf-ui-list-empty_lst");
                }
                else
                {
                    if ( data[firstIndex + elementId ] == undefined)
                    {
                        $(element).html("").addClass("sf-ui-list-empty_lst");
                    }
                    else
                    {
                        $(element).html(getElementContent(self, firstIndex + elementId)).removeClass("sf-ui-list-empty_lst");
                    }
                }
            }
            else
            {
                if ( data[firstIndex + elementId ] == undefined)
                {
                    $(element).html("").addClass("sf-ui-list-empty_lst");
                }
                else
                {
                    $(element).html(getElementContent(self, firstIndex + index)).removeClass("sf-ui-list-empty_lst");
                }
            }
            
        });
	}
    
    function getElementContent (self, index)
    {
        if ($(self).data("getElementContentCallback"))
        {
            if (index < 0 || index > $(self).data("data").length - 1)
            {
                alert("getElementContent: index out of range");
                return "";
            }
            else
            {
                return $(self).data("getElementContentCallback")($(self).data("data")[index]);
            }
        }
        else
        {
            alert("getElementContentCallback not implemented");
            return "";
        }
    }
    
    function clickElement (self, index)
    {
        if ($(self).data("clickElementCallback"))
        {
            if (index < 0 || index > $(self).data("data").length - 1)
            {
                alert("clickElement: index out of range");
                return false;
            }
            else
            {
                return $(self).data("clickElementCallback")($(self).data("data")[index]);
            }
        }
        else
        {
            alert("clickElementCallback not implemented");
            return false;
        }
    }
    
	function getPage (index, itemsPerPage)
    {
		var retValue = Math.floor(index/itemsPerPage);
		//alert("getPage("+index+","+itemsPerPage+") returns " + retValue);
		return retValue;
	}
	
	function getDiv (n)
    {
		var retValue = "";
		for (var i=0; i < n; i++)
        {
            retValue += "<div class='content' id='" +  i +"'></div>";
        }
		return retValue;
	}
    
	var stateClasses = "sf-ui-list-focused_lst sf-ui-list-blured_lst sf-ui-list-selected_lst";
	
})(jQuery);