(function($)
{
	$.fn.sfVideo2_controller = function(options)
    {
         //Verifies whether the stored data "sfui" have definition equals "Video2_controller" because the tag was create yet
		 if (!($(this).data("sfui") == "Video2_controller"))
         {
			$(this).data("sfui", "Video2_controller");
			
			var contents = [
                '<div id="mainVideo2_controller" class="main">',
                    '<div class="opacity"></div>',
                    '<div id="Video2_controllerBGUp" class="Video2_controllerBGUp">',
                        '<div id="Video2_controllerBGTime" class="Video2_controllerTime">',
                            '<div id="progressTime" class="progressTime" ></div>',
                        '</div>',
                        '<div id="timeInfo" class="time"></div>',
                    '</div>',
                    '<div id="Video2_controllerBGDown" class="Video2_controllerBGDown">',
                        '<div id="volumeIcon" class="unmute"></div>',
                        '<div id="Video2_controllerVolume" class="Video2_controllerVolume">',
                            '<div id="progressVolume" class="progressVolume" ></div>',
                        '</div>',
                        '<div id="volumeValue" class="volumeValue"></div>',
                        '<div id="buttons" class="buttons">',
                            '<div id="backwardButton" class="bkButton" ></div>',
                            '<div id="playButton" class="plButton" ></div>',
                            '<div id="stopButton" class="stButton" ></div>',
                            '<div id="pauseButton" class="paButton" ></div>',
                            '<div id="fowardButton" class="fwButton" ></div>',
                            '<div id="textButton" class="txButton"></div>',
                        '</div>',
                    '</div>',
                 '</div>'
			].join('');
			
            //insert the video tag
			$(this).html(contents);
        }
        
         if  (typeof options == "object")
         {
            $(this).setTime("00:00:00/00:00:00");
         }
         else if (typeof options == "string")
         {
            switch (options)
            {
                case "show":
                    $(this).show();
                    break;
                    
                case "hide":
                    $(this).hide();
                    break;
            }
        }
     }
    
    /**
     * Function responsible for change the button of progress area, that button can be: stop, play, pause, backward, forward
     */ 
     $.fn.changeButton = function(string, scrolling)
     {
        if (typeof scrolling == "undefined")
        {
            scrolling = true;
        }
        
        //reset the buttons
        $("#playButton").css("background-image", "url('images/video2_controller/play.png')" );
        $("#pauseButton").css("background-image", "url('images/video2_controller/pause.png')" );
        $("#stopButton").css("background-image", "url('images/video2_controller/stop.png')" );
        
        if (scrolling)
        {
            $("#backwardButton").css("background-image", "url('images/video2_controller/rew.png')" );
            $("#fowardButton").css("background-image", "url('images/video2_controller/ff.png')" );        
        }
        else
        {
            $("#backwardButton").css("background-image", "url('images/video2_controller/rew_sl.png')" );
            $("#fowardButton").css("background-image", "url('images/video2_controller/ff_sl.png')" );        
        }
        
        if ( string == "play" )
        {
            $("#playButton").css("background-image", "url('images/video2_controller/play_sl.png')" );
            $("#textButton").text("Odtwarzanie");
        }
        else if ( string == "pause")
        {
            $("#pauseButton").css("background-image", "url('images/video2_controller/pause_sl.png')" );
            $("#textButton").text("Pauza");
        }
        else if ( string == "stop" )
        {    
            $("#stopButton").css("background-image", "url('images/video2_controller/stop_sl.png')" );
            $(this).setProgress(0);
            $(this).setTime("00:00:00/00:00:00");
            $("#textButton").text("Stop");
        }
        else if ( string == "backward" )
        {
            $("#backwardButton").css("background-image", "url('images/video2_controller/rew_sl.png')" );
            $("#textButton").text("Przewijanie");
        }
        else if ( string == "forward" )
        {
            $("#fowardButton").css("background-image", "url('images/video2_controller/ff_sl.png')" );
            $("#textButton").text("Przewijanie");
        }
     }
     
     /**
      * Function to set up the time
      */
     $.fn.setTime = function(timeProgress)
     {
        if (timeProgress != "")
        {
            $("#timeInfo").html(timeProgress);
        }
        else
        {
            $("#timeInfo").html("00:00:00/00:00:00");
        }
     }
     
     /**
      * Function to set up the Progress
      */
     $.fn.setProgress = function(timePercent)
     {
        if (timePercent < 0)
        {
            $("#progressTime").css("width", "0%");
        }
        else if (timePercent > 100)
        {
            $("#progressTime").css("width", "100%");
        }
        else
        {
            $("#progressTime").css("width", timePercent + "%");
        }
     }
     
     $.fn.setBuffering = function(bufferPercent)
     {
        if (bufferPercent < 0)
        {
            $("#textButton").text("Buforowanie 0%");
        }
        else if (bufferPercent > 100)
        {
            $("#textButton").text("Buforowanie 100%");
        }
        else
        {
            $("#textButton").text("Buforowanie "+bufferPercent+"%");
        }
     }
     
     /**
      * Set the visibility for progress bar
      */
     $.fn.setVisible = function(valueVisible)
     {
        $(this).css("visibility", valueVisible);
     }
    
     /**
      * Function to set up the Volume progress
      */
     $.fn.setVolume = function(volumePercent)
     {
        $("#progressVolume").css("width", volumePercent + "%");
        $("#volumeValue").text(volumePercent);
     }
     
     /**
      * Set mute icon
      */
     $.fn.setMute = function(muteValue)
     {
        if (muteValue == "mute" || muteValue == "unmute")
        {
            $("#volumeIcon", this).removeClass("mute unmute").addClass(muteValue);
        }
     }
     
     /**
      * Show / hide volume controls
      */
     $.fn.setVolumeControlsVisible = function(valueVisible)
     {
        if (valueVisible)
        {
            $("#buttons").css("left", "195px");
            $("#buttons .txButton").css("left", "130px");
            $("#volumeIcon").show();
            $("#Video2_controllerVolume").show();
            $("#volumeValue").show();
        }
        else
        {
            $("#volumeIcon").hide();
            $("#Video2_controllerVolume").hide();
            $("#volumeValue").hide();
            $("#buttons").css("left", "15px");
            $("#buttons .txButton").css("left", "310px");
        }
     }
     
})(jQuery);